//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Sync_H
#define Moochos_Moa_Sync_H
//---------------------------------------------------------------------------
// Sync.h
//
// Version: 1.2.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Sync {
//---------------------------------------------------------------------------
class ESyncError : public Exception
{
public:
	__fastcall ESyncError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TMutex
{
private:
	HANDLE FHandle;
	int FLockCount;
	__fastcall TMutex(const TMutex& AOther); // Forbidden
	TMutex& __fastcall operator =(const TMutex& AOther); // Forbidden
	void __fastcall Initialize(const AnsiString& AName, bool ALock);
	void __fastcall Uninitialize();
	void __fastcall Create(const AnsiString& AName, bool ALock);
	void __fastcall Close();
protected:
public:
	__fastcall TMutex(const AnsiString& AName, bool ALock);
	__fastcall ~TMutex();
	void __fastcall Lock(int ATimeoutInterval = -1);
	bool __fastcall TryLock(int ATimeoutInterval = -1);
	void __fastcall Unlock();
	__property HANDLE Handle = {read=FHandle};
};
//---------------------------------------------------------------------------
class TCriticalSection
{
private:
	CRITICAL_SECTION FValue;
	int FLockCount;
	__fastcall TCriticalSection(const TCriticalSection& AOther); // Forbidden
	TCriticalSection& __fastcall operator =(const TCriticalSection& AOther); // Forbidden
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	CRITICAL_SECTION* __fastcall GetValue();
protected:
public:
	__fastcall TCriticalSection();
	__fastcall ~TCriticalSection();
	void __fastcall Lock();
	void __fastcall Unlock();
	__property CRITICAL_SECTION* Value = {read=GetValue};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Sync
using namespace Moochos::Moa::Sync;
//---------------------------------------------------------------------------
#endif

