//---------------------------------------------------------------------------
#ifndef Moochos_WheelHere_WheelHook_H
#define Moochos_WheelHere_WheelHook_H
//---------------------------------------------------------------------------
// WheelHook.h
//
// Version: 1.0.1
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Wheeler/EntryPoint.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace WheelHere { namespace WheelHook {
//---------------------------------------------------------------------------
class EWheelHookError : public Exception
{
public:
	__fastcall EWheelHookError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TWheelHook : public TObject
{
private:
	HINSTANCE FWheeler;
	typedef bool __stdcall (* TInner_Wheeler_IsEnabled)(bool& AEnabled);
	typedef bool __stdcall (* TInner_Wheeler_SetEnabled)(bool AEnabled);
	typedef bool __stdcall (* TInner_Wheeler_GetSettings)(Wheeler_TSettings& ASettings);
	typedef bool __stdcall (* TInner_Wheeler_SetSettings)(const Wheeler_TSettings& ASettings);
	TInner_Wheeler_IsEnabled FInner_Wheeler_IsEnabled;
	TInner_Wheeler_SetEnabled FInner_Wheeler_SetEnabled;
	TInner_Wheeler_GetSettings FInner_Wheeler_GetSettings;
	TInner_Wheeler_SetSettings FInner_Wheeler_SetSettings;
	TNotifyEvent FOnChange;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall DoChange();
	bool __fastcall GetEnabled();
	void __fastcall SetEnabled(bool AEnabled);
	Wheeler_TSettings __fastcall GetSettings();
	void __fastcall SetSettings(const Wheeler_TSettings& ASettings);
protected:
public:
	__fastcall TWheelHook();
	virtual __fastcall ~TWheelHook();
	__property bool Enabled = {read=GetEnabled, write=SetEnabled};
	__property Wheeler_TSettings Settings = {read=GetSettings, write=SetSettings};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::WheelHere::WheelHook
using namespace Moochos::WheelHere::WheelHook;
//---------------------------------------------------------------------------
#endif

