//---------------------------------------------------------------------------
// WheelCommon.cpp
//
// Version: 1.0.0 +
// Last modified: 2012-01-19 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <windows.h>
#pragma hdrstop
#include "WheelCommon.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace WheelHere { namespace Wheeler { namespace WheelCommon {
//---------------------------------------------------------------------------
namespace {
//---------------------------------------------------------------------------
} // End of namespace
//---------------------------------------------------------------------------
VOID ForceSetForegroundWindow(HWND AWindow)
{
	if(!TryForceSetForegroundWindow(AWindow)) {
		throw EWindowError();
	}
}
//---------------------------------------------------------------------------
BOOL TryForceSetForegroundWindow(HWND AWindow)
{
	if(::GetForegroundWindow() == AWindow) {
		return TRUE;
	}
	bool LAttached = false;
	DWORD LSrcId = ::GetCurrentThreadId();
	DWORD LDstId = ::GetWindowThreadProcessId(::GetForegroundWindow(), NULL);
	if(LSrcId != LDstId) {
		LAttached = ::AttachThreadInput(LSrcId, LDstId, true);
	}
	::BringWindowToTop(AWindow); // Said to be a patch for IE 5.5
	::SetForegroundWindow(AWindow);
	if(LAttached) {
		::AttachThreadInput(LSrcId, LDstId, false);
	}
	return ::GetForegroundWindow() == AWindow;
}
//---------------------------------------------------------------------------
HWND EnsureGetParent(HWND hWnd)
{
	::SetLastError(NO_ERROR);
	HWND returnValue = ::GetParent(hWnd);
	if(::GetLastError() != NO_ERROR) {
		throw EWindowError();
	}
	return returnValue;
}
//---------------------------------------------------------------------------
HWND EnsureGetWindow(HWND hWnd, UINT uCmd)
{
	::SetLastError(NO_ERROR);
	HWND returnValue = ::GetWindow(hWnd, uCmd);
	if(::GetLastError() != NO_ERROR) {
		throw EWindowError();
	}
	return returnValue;
}
//---------------------------------------------------------------------------
LONG_PTR EnsureGetWindowLongPtr(HWND hWnd, int nIndex)
{
	::SetLastError(NO_ERROR);
	LONG_PTR returnValue = ::GetWindowLongPtr(hWnd, nIndex);
	if(::GetLastError() != NO_ERROR) {
		throw EWindowError();
	}
	return returnValue;
}
//---------------------------------------------------------------------------
POINT MakePoint(LONG AX, LONG AY)
{
	POINT point;
	point.x = AX;
	point.y = AY;
	return point;
}
//---------------------------------------------------------------------------
}}}} // End of namespace Moochos::WheelHere::Wheeler::WheelCommon
using namespace Moochos::WheelHere::Wheeler::WheelCommon;
//---------------------------------------------------------------------------

